      -------------------- Définition des variables --------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
local addonName = "GearHelper"
local version = GetAddOnMetadata(addonName, "Version")
local versionCible = nil
--print("Version actuelle : "..version)
local prefix = "GeARHeLPeRPReFIX"--..version -- rajouter version si on veut que notre addon ne comunique QUE avec les GH de la même version
-- ^ Pour le préfix, choisir un nom qu'on est sûr que personne d'autre ne réutilisera
local L = GearHelperLocalization -- permet de récupérer le text dans toutes les langues

local allEvents = {}
local allPrefix = {["askVersion"..prefix] = sendAnswerVersion, ["answerVersion"..prefix] = receiveAnswer,}
local nbSlotsBag = {[0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0}
local eventHandler, waitAnswerFrame, loadFrame = CreateFrame("Frame"), CreateFrame("Frame"), CreateFrame("Frame")
local askTime, maxWaitTime = nil, 15
local bagInventory = {}
local charInventory = {}

local function getSubTypeStuff( idItem )
	local _, _, _, _, _, _, itemSubType, _, _, _, _ = GetItemInfo(idItem)
	return itemSubType
end
local nomsStuff = {

	["Maille"] = getSubTypeStuff( 87456 ),
	["Plaque"] = getSubTypeStuff( 87506 ),
	["Cuir"] = getSubTypeStuff( 87522 ),
	["Tissu"] = getSubTypeStuff( 87447 ),
	["Boucliers"] = getSubTypeStuff( 50616 ),
	["Dagues"] = getSubTypeStuff( 87467 ),
	["Armes de pugilat"] = getSubTypeStuff( 50710 ),
	["Haches à une main"] = getSubTypeStuff( 50737 ),
	["Masses à une main"] = getSubTypeStuff( 50734 ),
	["Haches à deux mains"] = getSubTypeStuff( 50709 ),
	["Masses à deux mains"] = getSubTypeStuff( 50603 ),
	["Épées à une main"] = getSubTypeStuff( 50732 ),
	["Épées à deux mains"] = getSubTypeStuff( 50730 ),
	["Armes d’hast"] = getSubTypeStuff( 50735 ),
	["Bâtons"] = getSubTypeStuff( 50648 ),
	["Arcs"] = getSubTypeStuff( 50638 ),
	["Arbalètes"] = getSubTypeStuff( 50732 ),
	["Armes à feu"] = getSubTypeStuff( 51834 ),
	["Baguettes"] = getSubTypeStuff( 50631 ),
	["Glaives de guerre"] = getSubTypeStuff( 128956 ),

}

local WARRIOR = {
	[1] = nomsStuff["Maille"],
	[2] = nomsStuff["Plaque"],
	[3] = nomsStuff["Boucliers"],
	[4] = nomsStuff["Dagues"],
	[5] = nomsStuff["Armes de pugilat"],
	[6] = nomsStuff["Haches à une main"],
	[7] = nomsStuff["Masses à une main"],
	[8] = nomsStuff["Épées à une main"],
	[9] = nomsStuff["Armes d’hast"],
	[10] = nomsStuff["Bâtons"],
	[11] = nomsStuff["Haches à deux mains"],
	[12] = nomsStuff["Masses à deux mains"],
	[13] = nomsStuff["Épées à deux mains"],
}

local PALADIN = {
	[1] = nomsStuff["Plaque"],
	[2] = nomsStuff["Boucliers"],
	[3] = nomsStuff["Haches à une main"],
	[4] = nomsStuff["Masses à une main"],
	[5] = nomsStuff["Épées à une main"],
	[6] = nomsStuff["Armes d’hast"],
	[7] = nomsStuff["Haches à deux mains"],
	[8] = nomsStuff["Masses à deux mains"],
	[9] = nomsStuff["Épées à deux mains"],
}

local HUNTER = {
	[1] = nomsStuff["Cuir"],
	[2] = nomsStuff["Maille"],
	[3] = nomsStuff["Arcs"],
	[4] = nomsStuff["Arbalètes"],
	[5] = nomsStuff["Armes à feu"],
	[6] = nomsStuff["Armes d’hast"],
} 

local ROGUE = {
	[1] = nomsStuff["Cuir"],
	[2] = nomsStuff["Dagues"],
	[3] = nomsStuff["Armes de pugilat"],
	[4] = nomsStuff["Haches à une main"],
	[5] = nomsStuff["Masses à une main"],
	[6] = nomsStuff["Épées à une main"],
}

local PRIEST = {
	[1] = nomsStuff["Tissu"],
	[2] = nomsStuff["Dagues"],
	[3] = nomsStuff["Masses à une main"],
	[4] = nomsStuff["Bâtons"],
	[5] = nomsStuff["Baguettes"],
}

local DEATH_KNIGHT = {
	[1] = nomsStuff["Plaque"],
	[2] = nomsStuff["Haches à une main"],
	[3] = nomsStuff["Haches à deux mains"],
	[4] = nomsStuff["Masses à une main"],
	[5] = nomsStuff["Masses à deux mains"],
	[6] = nomsStuff["Armes d’hast"],
	[7] = nomsStuff["Épées à deux mains"],
	[8] = nomsStuff["Épées à une main"],
}

local SHAMAN = {
	[1] = nomsStuff["Maille"],
	[2] = nomsStuff["Cuir"],
	[3] = nomsStuff["Boucliers"],
	[4] = nomsStuff["Dagues"],
	[5] = nomsStuff["Armes de pugilat"],
	[6] = nomsStuff["Haches à une main"],
	[7] = nomsStuff["Masses à une main"],
	[8] = nomsStuff["Masses à deux mains"],
	[9] = nomsStuff["Haches à deux mains"],
	[10] = nomsStuff["Bâtons"],
}

local MAGE = {
	[1] = nomsStuff["Tissu"],
	[2] = nomsStuff["Dagues"],
	[3] = nomsStuff["Épées à une main"],
	[4] = nomsStuff["Bâtons"],
	[5] = nomsStuff["Baguettes"],
}

local WARLOCK = {
	[1] = nomsStuff["Tissu"],
	[2] = nomsStuff["Dagues"],
	[3] = nomsStuff["Épées à une main"],
	[4] = nomsStuff["Bâtons"],
	[5] = nomsStuff["Baguettes"],
}

local MONK = {
	[1] = nomsStuff["Cuir"],
	[2] = nomsStuff["Bâtons"],
	[3] = nomsStuff["Haches à une main"],
	[4] = nomsStuff["Masses à une main"],
	[5] = nomsStuff["Épées à une main"],
	[6] = nomsStuff["Armes d’hast"],
	[7] = nomsStuff["Armes de pugilat"],
}

local DRUID = {
	[1] = nomsStuff["Cuir"],
	[2] = nomsStuff["Dagues"],
	[3] = nomsStuff["Armes de pugilat"],
	[4] = nomsStuff["Masses à une main"],
	[5] = nomsStuff["Armes d’hast"],
	[6] = nomsStuff["Masses à deux mains"],
	[7] = nomsStuff["Bâtons"],
}

local DEMON_HUNTER = {
	[1] = nomsStuff["Cuir"],
	[2] = nomsStuff["Glaives de guerre"],
	[3] = nomsStuff["Dagues"],
	[4] = nomsStuff["Épées à une main"],
	[5] = nomsStuff["Haches à une main"],
	[6] = nomsStuff["Armes de pugilat"],
}

-- NE PAS OUBLIER DE RAJOUTER LA VERSION PRÉCÉDENTE ICI APRÈS CHAQUE MISE A JOUR !!!!
--local anciennesVersions = {"0.0", "0.1", "0.2", "0.3"}
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
      ----------------- Fin de définition des variables -----------------
 
waitAnswerFrame:Hide()

-- Initialise la variable sur true la première fois qu'on utilise l'addon
-- Variable par perso, permet d'avoir différents profils
local function setDefault()
	GHActivated = true
	GHSGActivated = true
end

-- desc : Permet de changer l'état (on / off) de l'addon
-- entrée : booleen (true / false)
-- sortie : string (message indiquant si l'addon est sur on ou off)
-- commentaire :
local function setActivated( valeur )
	if valeur == true then
		GHActivated = true
		print(L["setOn"])
	elseif valeur == false then
		GHActivated = false
		print(L["setOff"])
	else
		print(L["errorSetActivatedValue"])
	end
end

-- permet d'activer/désactiver la vente d'objets gris
local function setGHSGActivated( valeur )
	if valeur == true then
		GHSGActivated = true
		print(L["setSGOn"])
	elseif valeur == false then
		GHSGActivated = false
		print(L["setSGOff"])
	else
		print(L[L["errorSetSGActivatedValue"]])
	end
end

-- desc : Envoie dans la guilde / raid / groupe une demande aux autres GH pour savoir s'ils sont à jour
-- entrée : ø
-- sortie : ø
-- commentaire :
local function sendAskVersion()
	if UnitInRaid("player") ~= nil then
		SendAddonMessage(prefix, "askVersion;"..version, "RAID")
	end
	if IsInGuild() == true then
		SendAddonMessage(prefix, "askVersion;"..version, "GUILD")
	end
	if UnitInParty("player") then
		SendAddonMessage(prefix, "askVersion;"..version, "PARTY")
	end
	askTime = time()
	waitAnswerFrame:Show()
end

-- desc : Quand on reçoit une demande de version, l'addon utilise cette fonction qui envoit la réponse
-- entrée : ø
-- sortie : ø
-- commentaire :
local function sendAnswerVersion()
	if UnitInRaid("player") ~= nil then
		SendAddonMessage(prefix, "answerVersion;"..version, "RAID")
	end
	if IsInGuild() then
		SendAddonMessage(prefix, "answerVersion;"..version, "GUILD")
	end
	if UnitInParty("player") then
		SendAddonMessage(prefix, "answerVersion;"..version, "PARTY")
	end
end

-- desc : Vérifie si l'addon est à jour quand il recoit une réponse 
-- entrée : string (version de la cible), string (nom de la cible)
-- sortie : string (message si l'addon n'est pas à jour, sinon rien)
-- commentaire :
local function receiveAnswer( msgV, msgC )
	if askTime then
		local answerCible = msgC:sub(msgC:find("-") - 1, #msgC)
			if tonumber(versionCible) > tonumber(GetAddOnMetadata(addonName, "Version")) then
				if L["local"] == "FR" then
					print("Vous utilisez la version |cFFFF0000"..version.."|r de GearHelper. La version |cFF00FF00"..msgV.."|r a été trouvée chez "..msgC)
				elseif L["local"] == "US" or L["local"] == "DE" then
					print("You are using version |cFFFF0000"..version.."|r of GearHelper. Version |cFF00FF00"..msgV.."|r was find from "..msgC)
				end
				askTime = nil
				waitAnswerFrame:Hide()
		end
	end
end
waitAnswerFrame:SetScript("OnUpdate", function ( self, elapsed )
	if askTime and (time() - askTime) > maxWaitTime then
		askTime = nil
		waitAnswerFrame:Hide()
	end
end)


-------------------------------------------------------------------------------
								-- FONCTIONS --
-------------------------------------------------------------------------------

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire : itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID)
local function testSiObjetGris( itemID ) -- itemID ou itemLink ou itemName ou itemString
	local _, _, itemRarity, _, _, _, _, _, _, _, _ = GetItemInfo(itemID)
	if itemRarity == 0 then
		return true
	else 
		return false
	end
	if itemRarity == nil then 
		return false
	end
end

-- desc :
-- entrée :
-- sortie :
-- commentaire : creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected, mountID  = C_MountJournal.GetDisplayedMountInfo(i)
local function testSiMonture( idMonture )
	local i = 1
	local creatureName, spellID, _, _, _, _, _, _, _, _, _, _  = C_MountJournal.GetDisplayedMountInfo(i)
	while creatureName ~= nil do
		if spellID == idMonture then
			return true
		end
		i = i + 1
		creatureName, spellID, _, _, _, _, _, _, _, _, _, _  = C_MountJournal.GetDisplayedMountInfo(i)
	end 
	return false
end

local  function testSiUtilisable( idObjet )
	local _, _, _, _, _, itemType, _, _, itemEquipLoc, _, itemSellPrice = GetItemInfo(idObjet)
	if itemType == L["armor"] or itemType == L["weapon"] then -- a changer pour les anglais
		if not IsDressableItem(idObjet) then
			if (itemSellPrice / 100 / 100) >= 1 then
				return false
			end
		end
	end
end

-- desc : Comme son nom l'indique permet d'effectuer une pause avant 
-- entrée : int(durée d'attente), func(la fonction a effectuer après l'attente)
-- sortie : l'exécution de la fonction passée en entré
-- commentaire :
local function wait( duree, fonction, timer )
	local waitFrame = CreateFrame("Frame")

	waitFrame:SetScript("OnUpdate", function ( self, elapsed )
		if time() >= timer + duree then
			if fonction then
				fonction()
			end
			waitFrame:Hide()
		end
		end)
end

-- desc : Cette fonction permet de récupérer le nombre de slots dans l'inventaire du joueur
-- entrée : ø
-- sortie : ø
-- commentaire :
local function nbSlotsTotal()
	local nbSlots = 0
	local i = 0
	while i <= 4 do
		if GetContainerNumSlots(i)  then
			nbSlots = nbSlots + GetContainerNumSlots(i)
		end
		i = i + 1
	end
	return nbSlots
end

-- desc : Inventoriage des sacs
-- entrée : 
-- sortie : 
-- commentaire :
local function scanBag()
	local count = 0
	for bag = 0,4 do
    	for slot = 1,GetContainerNumSlots(bag) do
			local itemID = GetContainerItemLink(bag, slot)
    		--Faire un getinventoryitemid pour tester si y'a bien un item et ensuite getinventoryitemlink pour recup le lien et non pas l'id de transmog
	  		if itemID ~= nil then
          		table.insert(bagInventory, parseID(itemID))
				count  = count + 1
	  		end
    	end
  	end
end

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :
local function scanCharacter()
    local count = 0
    if GetInventoryItemLink("player",GetInventorySlotInfo("HeadSlot")) ~= nil then
      charInventory["Head"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("HeadSlot")))
    else
      charInventory["Head"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("NeckSlot")) ~= nil then
      charInventory["Neck"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("NeckSlot")))
      else
      charInventory["Neck"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("ShoulderSlot")) ~= nil then
     charInventory["Shoulder"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("ShoulderSlot")))
      else
      charInventory["Shoulder"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("BackSlot")) ~= nil then
      charInventory["Back"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("BackSlot")))
      else
      charInventory["Back"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("ChestSlot")) ~= nil then
      charInventory["Chest"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("ChestSlot")))
      else
      charInventory["Chest"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("WristSlot")) ~= nil then
      charInventory["Wrist"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("WristSlot")))
      else
      charInventory["Wrist"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("HandsSlot")) ~= nil then
      charInventory["Hands"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("HandsSlot")))
      else
      charInventory["Hands"] =  0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("WaistSlot")) ~= nil then
      charInventory["Waist"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("WaistSlot")))
      else
      charInventory["Waist"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("LegsSlot")) ~= nil then
      charInventory["Legs"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("LegsSlot")))
      else
      charInventory["Legs"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("FeetSlot")) ~= nil then
      charInventory["Feet"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("FeetSlot")))
      else
      charInventory["Feet"] =  0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Finger0Slot")) ~= nil then
      charInventory["Finger0"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Finger0Slot")))
      else
      charInventory["Finger0"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Finger1Slot")) ~= nil then
      charInventory["Finger1"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Finger1Slot")))
      else
      charInventory["Finger1"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Trinket0Slot")) ~= nil then
      charInventory["Trinket0"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Trinket0Slot")))
      else
      charInventory["Trinket0"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("Trinket1Slot")) ~= nil then
      charInventory["Trinket1"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("Trinket1Slot")))
      else
      charInventory["Trinket1"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot")) ~= nil then
      charInventory["MainHand"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot")))
      else
      charInventory["MainHand"] = 0
    end
    if GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot")) ~= nil then
      charInventory["SecondaryHand"] = parseID(GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot")))
      else
      charInventory["SecondaryHand"] = 0
    end
end

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :
local function parseID(link)
  local a = string.match(link, "item[%-?%d::]+")
  local b = string.sub(a, 5, 12)
  local c = string.gsub(b, ":", "")
  return c
end

local function testSiEquipable( classe, number )
	local _, _, _, _, _, _, itemSubType, _, _, _, _ = GetItemInfo(number)


	if classe == "WARRIOR" then
		for k,v in pairs(WARRIOR) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "PALADIN" then
		for k,v in pairs(PALADIN) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "HUNTER" then
		for k,v in pairs(HUNTER) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "ROGUE" then
		for k,v in pairs(ROGUE) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "PRIEST" then 
		for k,v in pairs(PRIEST) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "DEATH KNIGHT" then
		for k,v in pairs(DEATH_KNIGHT) do
			--print("Valeur pour priest : "..v)
			--print("Valeur item : "..itemSubType)
			if v == itemSubType then
				print("true")
				return true
			end
		end
		return false
	end
	if classe == "SHAMAN" then
		for k,v in pairs(SHAMAN) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "MAGE" then 
		for k,v in pairs(MAGE) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "WARLOCK" then
		for k,v in pairs(WARLOCK) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "MONK" then
		for k,v in pairs(MONK) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end
	if classe == "DRUID" then
		for k,v in pairs(DRUID) do
			if v == itemSubType then
				--print("Valeur pour druide : "..v)
				--print("Valeur item : "..itemSubType)
				--print("true")
				return true
			end
		end
		print("false")
		return false
	end
	if classe == "DEMON HUNTER" then
		for k,v in pairs(DEMON_HUNTER) do
			if v == itemSubType then
				return true
			end
		end
		return false
	end 
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

----------------------
-- Helper functions --				Pour ceux qui se demandent, oui, je dessine mieux en ASCII que je ne code
----------------------
--local function getCommand( command, instruction)
--	return "|cFFFF7D0A"..command.." : |r"..instruction
--end

--------------------
-- Slash commands --
--------------------
local allCommands = {
	--void = "|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r",
	on = L["onHelpInfo"],
	off = L["offHelpInfo"],
	state = L["stateHelpInfo"],
	sgon = L["sgonHelpInfo"],
	sgoff = L["sgoffHelpInfo"],
}

local slashCmdFunc = {
	voidcommand = function ( msg )
		print("|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r")
	end,
	on = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	enable = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	activated = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	off = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	disable = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	deactivated = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	help = function ( msg )
		print(allCommands.on)
		print(allCommands.off)
		print(allCommands.state)
		print(allCommands.sgon)
		print(allCommands.sgoff)
	end,
	state = function ( msg )
		if GHActivated == true then
			print(L["stateFuncOn"])
		else
			print(L["stateFuncOff"])
		end
	end,
	list = function ( msg )
		scanBag()
	 	scanCharacter()
	 	for k, v in pairs( charInventory ) do
	   		print(k, v)
		end
	 	for a = 1, #bagInventory do
	    	print(bagInventory[a])
	  	end
	end,
	sgon = function ( msg )
		if GHSGActivated == false then
			setGHSGActivated(true)
		end
	end,
	sgoff = function ( msg )
		if GHSGActivated == true then
			setGHSGActivated(false)
		end
	end,
}

-- Activation de /cmd
local cmd1 = "/gh"
local cmd2 = "/gearhelper"
SLASH_GEARHELPER1 = cmd1:lower()
SLASH_GEARHELPER2 = cmd2:lower()
-- Fin d'activation des /cmd
-- Déclaration des /cmd
SlashCmdList["GEARHELPER"] = function ( msg )
	local instruction = msg:match("%a+")
	if instruction then 
		instruction = instruction:lower() 
	end
	if msg == "" then
		slashCmdFunc["help"](msg)
	elseif slashCmdFunc[instruction] then
		slashCmdFunc[instruction](msg)
	else
		slashCmdFunc["voidcommand"](msg)
	end
--end
end
-- Fin déclaration des /cmd

-------------------
-- Event handler --
-------------------

-- Se déclenche quand les addons se chargent
function allEvents:ADDON_LOADED( name )
	if name == addonName then
		-- charge le préfix de l'addon (ou un truc du genre)
		RegisterAddonMessagePrefix(prefix) 

		-- Active l'addon par défaut lors de la première connexion après l'installation
		if GHActivated == nil or GHSGActivated == nil then
			setDefault() 
		end

		-- Affiche à chaque connection l'état de l'addon
		if GHActivated == true then 
			print(L["setOn"]) 
			--sendAskVersion()
		else 
			print(L["setOff"]) 
		end
	end
end

-- Se déclenche quand un message d'addon arrive
function allEvents:CHAT_MSG_ADDON( prefixMessage, message, channel, sender )
	local emeteur = sender:sub(0, (sender:find("-") - 1))
	if GHActivated == true then
		if emeteur ~= GetUnitName("player") then
			if prefixMessage == prefix then
				local prefVersion = message:sub(0, (message:find(";") - 1))
				if prefVersion == "answerVersion" then
				local vVersion = message:sub(message:find(";")+1, #message)
				versionCible = vVersion
				receiveAnswer(vVersion, sender)
			end
			if prefVersion == "askVersion" then
				sendAnswerVersion()
			end
		end
	end
end
end

-- Quand un objet attérie dans l'inventaire --bag : 0, 1, 2, 3 ou 4
function allEvents:ITEM_PUSH( bag )
	-- body
	--print(bag)
end

-- Evenement se déclenche quanduand un arrive sur la page de la quête terminée (la ou il faut choisir la récompense)
function allEvents:QUEST_COMPLETE()
	-- body
end

-- Evenement se déclenche à chaque écran de chargement
function allEvents:PLAYER_ENTERING_WORLD()
	if GHActivated == true then
		sendAskVersion()
	end
end

-- Evenement se déclanche quand la fenêtre besoin/cupi pop en donjon
function allEvents:START_LOOT_ROLL(number)
	-- classeEN est la même, quelle que soit la langue du client
	local classeFR, classeEN, classeNumber = UnitClass("player")
	local link, name, _, _, bindOnPickUp, canNeed, canGreed, _, _, _, _, _ = GetLootRollItemInfo(number)
	local _, _, _, _, _, _, itemSubType, _, _, _, _ = GetItemInfo(name)

	-- number = ID de l'objet à roll
	-- rollType = 0 pass, 1 need, 2 cupi
	-- ConfirmLootRoll(number, rollType)

	if testSiMonture(name) then
		ConfirmLootRoll(number, 1)
	end


	if canNeed == false then
		ConfirmLootRoll(number, 2)
		--print("J'ai fais cupi, tu ne pouvais pas need")
	end
	if canNeed == true and testSiEquipable(classeEN, name) == false then
		ConfirmLootRoll(number, 2)
		--print("Tu ne peux pas l'équiper, c'est du "..itemSubType.." je fais cupi")
		--print("C'est "..link)
	end
end
function allEvents:UNIT_INVENTORY_CHANGED( joueur )
	-- print("Joueur : "..joueur)
end

-- Evenement se déclenche quand on ouvre la fenetre d'un vendeur
function allEvents:MERCHANT_SHOW()
	if GHSGActivated then
		for bag = 0,4 do
    		for slot = 1,GetContainerNumSlots(bag) do
		  		if GetContainerItemID(bag, slot) ~= nil then
		  			id = GetContainerItemID(bag, slot)
					if id then
						if testSiObjetGris(id) then
							UseContainerItem(bag, slot)
						end
					end
				end
    		end
  		end
  	end
end
--------------------------------------------
-- xxxxx xxxxxxx --      -- xxxxx xxxxxxx --
--------------------------------------------

for event, _ in pairs(allEvents) do
	eventHandler:RegisterEvent(event)
end
eventHandler:SetScript("OnEvent", function ( self, event, ... )
	if GHActivated == true or GHActivated == nil then
		allEvents[event](self, ...)
	end
	end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


--------------



-- pour chaques piece de stuff
-- faire une recherche dans l'inventaire
-- regarder s'il existe un stuff du même type
-- si oui, regarder s'il est meilleurs que celui qu'on à
-- si oui l'équiper
-- si non, le laisser dans l'inventaire


-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :


